'''A Wizard Prestige Class'''

import es, popuplib, dnds, random, math, gamethread
from dnds import dnds

SpellCommands = ['poison', 'fiend', 'massbear', 'blackfire']

def load():
    dnds.addPrestigeClass('Acolyte of Skin', 'Wizard', 10)

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/AcolyteOfSkin/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/AcolyteOfSkin/%s'%command)
    
    acolyteofskininfo = popuplib.create('acolyteofskininfo')
    acolyteofskininfo.addline('-{ D&D CS:S - Acolyte of Skin Info }-')
    acolyteofskininfo.addline(' Required Level: 10 ')
    acolyteofskininfo.addline(' Half Casting Progression ')
    acolyteofskininfo.addline('-> 1. Passive Skills')
    acolyteofskininfo.addline('-> 2. Active Spells/Skills')
    acolyteofskininfo.addline('-> 8. Back')
    acolyteofskininfo.addline('0. Exit')
    acolyteofskininfo.submenu(1, 'acolyteofskinpassive')
    acolyteofskininfo.submenu(2, 'acolyteofskinspells')
    acolyteofskininfo.submenu(8, 'Wizardprestigeinfo 1')
    dnds.addPrestigeInformation('Acolyte of Skin', 'acolyteofskininfo')

    acolyteofskinpassive = popuplib.create('acolyteofskinpassive')
    acolyteofskinpassive.addline('-{ Acolyte Passive Skills }-')
    acolyteofskinpassive.addline(' Lvl 1: Wear Fiend - Gain DR and a small Dodge Chance')
    acolyteofskinpassive.addline(' Lvl 5: Skin Adaptation - Increased DR')
    acolyteofskinpassive.addline(' Lvl 10: Fiendish Symbiosis - One last DR Boost and Health Bonus')
    acolyteofskinpassive.addline('-> 8. Back')
    acolyteofskinpassive.addline('0. Exit')
    acolyteofskinpassive.submenu(8, 'acolyteofskininfo')

    acolyteofskinspells = popuplib.create('acolyteofskinspells')
    acolyteofskinspells.addline('-{ Acolyte Active Skills }-')
    acolyteofskinspells.addline(' Lvl 1: Poison (1/rnd) - Reduce your target\'s max health for a short time (poison)')
    acolyteofskinspells.addline(' Lvl 4: Fiendform - Gain health, damage, and regeneration but loose casting for 20 sec (fiend)')
    acolyteofskinspells.addline(' Lvl 5: Poison (2/rnd)')
    acolyteofskinspells.addline(' Lvl 8: Bear\'s Endurance, Mass - Boost all nearby teamates health (massbear)')
    acolyteofskinspells.addline(' Lvl 10: Blackfire - Damage and burn your target that can\'t be healed (blackfire)')
    acolyteofskinspells.addline('-> 8. Back')
    acolyteofskinspells.addline('0. Exit')
    acolyteofskinspells.submenu(8, 'acolyteofskininfo')

    acolytecast = popuplib.create('Acolyte of Skincast')
    acolytecast.addline('-{ Acolyte Casting XM XH }-')
    acolytecast.addline('-> 1. Poison (Uses Left: 0)')
    acolytecast.addline('-> 2. Fiendform 2M')
    acolytecast.addline('-> 3. Bear\'s Endurance Mass 3M')
    acolytecast.addline('-> 4. Blackfire 1H')
    acolytecast.addline('-> 8. Back')
    acolytecast.addline('0. Exit')
    acolytecast.submenu(8, 'Wizardcast')
    acolytecast.prepuser = acolyteCastPrep
    acolytecast.menuselect = acolyteCast

def poison():
    userid = es.getcmduserid()
    Key = dnds.getPlayer(userid)
    if Key['poison']:
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, poisonRun, (userid))
    else:
        es.tell(userid, '#multi', 'Your are out of poison uses this round!')

def poisonRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    Key = dnds.getPlayer(userid)
    if target and Key['poison']:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 960:
            UKey = dnds.getPlayer(target)
            if 'poison' not in UKey['buffs']:
                dnds.Buffs(target, 'poison', 15)
                dnds.Beam2(userid, target, 1, 0, 255, 0)
                dnds.TempHealthOff(target, random.randrange(10, 45, 5), 15)
                Key['poison'] -= 1
                es.tell(userid, '#multi', 'You have poisoned %s for the next 15 seconds!'%es.getplayername(target))
                es.tell(target, '#multi', 'You have been poisoned and lost health...')
                dnds.Delayed(target, 15, es.tell, (target, '#multi', 'The poison has worn off.'))
            else:
                es.tell(userid, '#multi', '%s is already poisoned!'%es.getplayername(target))

def fiend():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 4, 'Acolyte of Skin'):
        Key = dnds.getPlayer(userid)
        if 'buffed' not in Key['buffs']:
            Key['spells'][2] -= 2
            dnds.Buffs(userid, 'buffed', 20)
            dnds.Buffs(userid, 'regeneration', 20)
            dnds.Buffs(userid, 'damage', 20)
            dnds.Buffs(userid, 'health', 20)
            dnds.TempHealth(userid, 75, 20)
            Key['buff'] += .3
            es.server.queuecmd('est_SetPlayerColor %s 255 0 0 255 1'%userid)
            es.tell(userid, '#multi', 'You have entered a fiend state for the next 20 seconds!')
            dnds.Regeneration(userid, 1, 2, 20)
            dnds.spellDelay(userid, 20)

def fiendOff(userid):
    es.tell(userid, '#multi', 'You have come out of your fiend form...')
    Key = dnds.getPlayer(userid)
    Key['buff'] -= .3
    es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)

def massbear():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 3, 8, 'Acolyte of Skin'):
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 3
        dnds.spellDelay(userid, 8)
        x1,y1,z1 = es.getplayerlocation(userid)
        for player in es.getUseridList():
            if es.getplayerteam(player) == es.getplayerteam(userid):
                x2,y2,z2 = es.getplayerlocation(player)
                if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 720:
                    UKey = dnds.getPlayer(player)
                    if 'health' not in UKey['buffs']:
                        dnds.Buffs(player, 'health', 20)
                        dnds.TempHealth(player, 40, 20)
                        if player != userid:
                            es.tell(player, '#multi', '%s has granted you bonus health with Bear\'s Endurance'%es.getplayername(userid))
                            dnds.giveXp(userid, 5, 'buffing an ally')
                        dnds.Delayed(player, 20, es.tell, (player, '#multi', 'Your bonus health from Bear\'s Endurance has worn off.'))
                        es.tell(userid, '#multi', 'You have cast Bear\'s Endurance on %s'%es.getplayername(player))

def blackfire():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 1, 10, 'Acolyte of Skin'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, blackfireRun, (userid))

def blackfireRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam1(userid, target, 1, 155, 0, 125)
            dnds.TempHealthOff(target, random.randrange(35, 85, 5))
            es.server.queuecmd('est_Burn %s 5'%target)
            es.tell(target, '#multi', 'You have been hit by blackfire!')
            es.tell(userid, '#multi', 'You have hit %s with blackfire!'%es.getplayername(target))
            dnds.Damage(target, userid, 1)
            dnds.spellDelay(userid, 4)
            Key = dnds.getPlayer(userid)
            Key['spells'][3] -= 1

def acolyteCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'poison')
    elif choice == 2:
        es.cexec(userid, 'fiend')
    elif choice == 3:
        es.cexec(userid, 'massbear')
    elif choice == 4:
        es.cexec(userid, 'blackfire')

def acolyteCastPrep(userid, popupid):
    popup = popuplib.find('Acolyte of Skincast')
    Key = dnds.getPlayer(userid)
    level = dnds.getLevel(userid, 'Acolyte of Skin')
    popup.modline(1, '-{ Acolyte Casting - %sM - %sH }-'%(Key['spells'][2], Key['spells'][3]))
    if Key['poison']:
        popup.modline(2, '-> 1. Poison (Uses Left: %s)'%Key['poison'])
    else:
        popup.modline(2, ' Poison (Uses Left: 0)')
    if level >= 4:
        if Key['spells'][2] < 2:
            popup.modline(3, ' Fiendform 2M')
        else:
            popup.modline(3, '-> 2. Fiendform 2M')
    else:
        popup.modline(3, '')
    if level >= 8:
        if Key['spells'][2] < 3:
            popup.modline(4, ' Bear\'s Endurance, Mass 3M')
        else:
            popup.modline(4, '-> 3. Bear\'s Endurance, Mass 3M')
    else:
        popup.modline(4, '')
    if level >= 10:
        if Key['spells'][3] < 1:
            popup.modline(5, ' Blackfire 1H')
        else:
            popup.modline(5, '-> 4. Blackfire 1H')
    else:
        popup.modline(5, '')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    Key['poison'] = 0
    if dnds.isPrestige(userid, 'Acolyte of Skin'):
        level = dnds.getLevel(userid, 'Acolyte of Skin')
        Key['spells'][1] += level/2
        if level >= 1:
            Key['damage reduction'] += .05
            Key['dodge percent'] += 5
            Key['dodge max damage'] = 100
            Key['poison'] += 1
        if level >= 5:
            Key['damage reduction'] += .05
            Key['poison'] += 1
        if level >= 10:
            Key['damage reduction'] += .05
        if level >= 5:
            Key['spells'][2] += level/5
        if level >= 10:
            Key['spells'][3] += 1
