'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib
from dnds import dnds

def load():
    dnds.addRace('Ethereal Filcher', monsterRace=True, bpRequired=1, bonusWeapons=['knife'])
    
    etherealinfo = popuplib.create('etherealinfo')
    etherealinfo.addline('-{ D&D CS:S - Ethereal Filcher Info }-')
    etherealinfo.addline(' Required Bonus Points: 1')
    etherealinfo.addline(' Weapons: Knife ')
    etherealinfo.addline(' Only Weapon is Visible ')
    etherealinfo.addline(' 25 Health')
    etherealinfo.addline(' Commands:')
    etherealinfo.addline('-> 1. List of Commands')
    etherealinfo.addline('-> 8. Back')
    etherealinfo.addline('0. Exit')
    etherealinfo.submenu(1, 'etherealcommandlist')
    etherealinfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('Ethereal Filcher', 'etherealinfo', monsterRace=True, bpRequired=1)
    
    etherealinfo = popuplib.create('etherealcommandlist')
    etherealinfo.addline('-{ D&D CS:S - Ethereal Filcher Command List }-')
    etherealinfo.addline(' - lev0 (Return Gravity)')
    etherealinfo.addline(' - lev1 (50% Gravity)')
    etherealinfo.addline(' - lev2 (20% Gravity)')
    etherealinfo.addline(' - lev3 (1% Gravity)')
    etherealinfo.addline(' - save1, tele1 (Save Location 1 & Teleport)')
    etherealinfo.addline(' - save2, tele2 (Save Location 2 & Teleport)')
    etherealinfo.addline('-> 8. Back')
    etherealinfo.addline('0. Exit')
    etherealinfo.submenu(8, 'etherealinfo')

    for c in ['lev0', 'lev1', 'lev2', 'tele1', 'tele2', 'save1', 'save2']:
        dnds.Commands[c]['Races'].append('Ethereal Filcher')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Ethereal Filcher'):
        Key = dnds.getPlayer(userid)
        dnds.Health(userid, -75)
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 0 0'%userid)
        Key['tele count'] = 7
