'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib
from dnds import dnds

def load():
    dnds.addRace('Rok', monsterRace=True, bpRequired=4, bonusWeapons=['scout', 'knife'])
    
    rokinfo = popuplib.create('rokinfo')
    rokinfo.addline('-{ D&D CS:S - Rok Info }-')
    rokinfo.addline(' Required Bonus Points: 4')
    rokinfo.addline(' Weapons: Scout and Knife ')
    rokinfo.addline(' You are Stealthed ')
    rokinfo.addline(' 70 Health')
    rokinfo.addline(' Commands:')
    rokinfo.addline(' - lev0 (Normal Gravity)')
    rokinfo.addline(' - lev1 (50% Gravity)')
    rokinfo.addline(' - lev2 (20% Gravity)')
    rokinfo.addline(' - lev3 (1% Gravity)')
    rokinfo.addline('-> 8. Back')
    rokinfo.addline('0. Exit')
    rokinfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('Rok', 'rokinfo', monsterRace=True, bpRequired=4)

    for c in ['lev0', 'lev1', 'lev2', 'lev3']:
        dnds.Commands[c]['Races'].append('Rok')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Rok'):
        Key = dnds.getPlayer(userid)
        dnds.Health(userid, -30)
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 40 1'%userid)
        dnds.Cash(userid, 2750, True)
