'''Thri-Kreen race for D&D 3.5 Mod'''

import es, dnds, popuplib, random
from dnds import dnds

def load():
    dnds.addRace('Thri-Kreen', levelAdjustment=3)
    
    thrikreeninfo = popuplib.create('thrikreeninformation')
    thrikreeninfo.addline('-{ D&D CS:S - Thri-Kreen Info }-')
    thrikreeninfo.addline(' Level Adjustment - 3')
    thrikreeninfo.addline(' Passive Skills:')
    thrikreeninfo.addline(' - Thri-Kreen Poison (Stun)')
    thrikreeninfo.addline(' - High Jumping')
    thrikreeninfo.addline(' - +10% Damage')
#    thrikreeninfo.addline(' - Ten Extra Power Points')
    thrikreeninfo.addline('-> 8. Back')
    thrikreeninfo.addline('0. Exit')
    thrikreeninfo.submenu(8, 'laracesinfo 1')
    dnds.addRaceInformation('Thri-Kreen', 'thrikreeninformation', levelAdjustment=3)

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Thri-Kreen'):
        Key = dnds.getPlayer(userid)
        Key['power points'] += 10
        Key['jump'] += .25
        Key['buff'] += .1
        dnds.Gravity(userid, -.2)

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0':
        attacker = int(ev['attacker'])
        damage = int(float(ev['dmg_health']))
        if dnds.isRace(attacker, 'Thri-Kreen'):
            if damage >= random.randint(1, 200):
                dnds.Stun(ev['userid'], 1)
                es.tell(attacker, '#multi', '#defaultYou have stunned %s with your Thri-Kreen Poison'%es.getplayername(ev['userid']))
