'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib, random
from dnds import dnds

def load():
    dnds.addRace('Tibbit', monsterRace=True, bpRequired=0, bonusWeapons=['knife'])
    
    tibbitinfo = popuplib.create('tibbitinfo')
    tibbitinfo.addline('-{ D&D CS:S - Tibbit Info }-')
    tibbitinfo.addline(' Required Bonus Points: 0')
    tibbitinfo.addline(' Weapons: USP & Knife ')
    tibbitinfo.addline(' You are Stealthed ')
    tibbitinfo.addline(' 90 Health')
    tibbitinfo.addline(' Sneak Attack - Additional Damage When Stealthed')
    tibbitinfo.addline(' Cat Form: Knife Only, 60% Dodge, Gain 20% Speed, High Jumping')
    tibbitinfo.addline(' Commands:')
    tibbitinfo.addline(' - cat (Toggle Cat Form)')
    tibbitinfo.addline('-> 8. Back')
    tibbitinfo.addline('0. Exit')
    tibbitinfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('Tibbit', 'tibbitinfo', monsterRace=True, bpRequired=0)

    if not es.exists('saycommand', 'cat'):
        es.regsaycmd('cat', 'dnds/SubScripts/Tibbit/cat')
    if not es.exists('clientcommand', 'cat'):
        es.regclientcmd('cat', 'dnds/SubScripts/Wizard/cat')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Tibbit'):
        Key = dnds.getPlayer(userid)
        dnds.Health(userid, -10)
        Key['cat'] = False
        Key['dodge max damage'] = 100
        Key['extra weapons'].append('usp')
        es.server.queuecmd('est_RemoveWeapon %s 2'%userid)
        es.server.queuecmd('es_xgive %s weapon_usp'%userid)
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 40 1'%userid)

def sneak_attack(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if dnds.isRace(attacker, 'Tibbit'):
        bonus = random.randrange(10, 60, 5)
        es.tell(attacker, '#multi', '#defaultYou have dealt %s bonus damage with a sneak attack!'%bonus)
        dnds.Damage(userid, attacker, bonus)

def cat():
    userid = es.getcmduserid()
    Key = dnds.getPlayer(userid)
    if dnds.isRace(userid, 'Tibbit') and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        if 'cat' in Key:
            if Key['cat']:
                Key['dodge percent'] -= 60
                dnds.Speed(userid, -.2)
                Key['cat'] = False
                Key['jump'] -= .1
                Key['extra weapons'].append('usp')
                es.server.queuecmd('es_xgive %s weapon_usp'%userid)
                es.server.queuecmd('playerset clip %s 0'%userid)
                es.server.queuecmd('est_SetPlayerColor %s 255 255 255 40 1'%userid)
                es.tell(userid, '#multi', 'You are a halfling again!')
            else:
                Key['dodge percent'] += 60
                dnds.Speed(userid, .2)
                Key['cat'] = True
                Key['jump'] += .1
                if 'usp' in Key['extra weapons']:
                    Key['extra weapons'].remove('usp')
                es.server.queuecmd('est_RemoveWeapon %s weapon_usp'%userid)
                es.tell(userid, '#multi', 'You have turned into a cat! Meow!')
        else:
            Key['cat'] = False

